/*
Solution of the problem antena. This solution uses incremental algorithm
and finds the result in O(n) expected time.
*/
#include <stdio.h>
#include <math.h>

#define true 1
#define false 0
typedef int bool;

struct TIntPoint{
	int x,y;
};

struct TPoint{
	float x,y;
};

class TCircle{
public:
	TPoint center;
	float radius;
};
//-------------------------------------------------------------------
void getData();
TCircle smallestCircle();
TCircle smallestCircle(TIntPoint, int);
TCircle smallestCircle(TIntPoint, TIntPoint, int);
TCircle getCircle(TIntPoint, TIntPoint);
TCircle getCircle(TIntPoint, TIntPoint, TIntPoint);
bool collinear(TIntPoint, TIntPoint, TIntPoint);
void swap(TIntPoint&, TIntPoint&);
float distance(TIntPoint p1, TIntPoint p2)
{
	return sqrt(pow(p1.x-p2.x,2)+pow(p1.y-p2.y,2));
}
float distance (TIntPoint p1, TPoint p2)
{
	return sqrt(pow(p1.x-p2.x,2)+pow(p1.y-p2.y,2));
}
float distance (TPoint p1, TPoint p2)
{
	return sqrt(pow(p1.x-p2.x,2)+pow(p1.y-p2.y,2));
}
//-------------------------------------------------------------------
FILE *fin = fopen("antena.in", "rt");
FILE *fout = fopen("antena.out","wt");

int n;
TIntPoint points[15001];
//-------------------------------------------------------------------
int main()
{
	getData();
	TCircle circle = smallestCircle();
	fprintf(fout,"%.3f %.3f\n%.3f",circle.center.x,circle.center.y,circle.radius);
	fclose(fin);
	fclose(fout);
	return 0;
}
//-------------------------------------------------------------------
//read the input file
void getData()
{
	TIntPoint p;
	int posxMin=1, posxMax=1,
		 posyMin=1, posyMax=1;
	fscanf(fin,"%d/n",&n);
	fscanf(fin,"%d%d/n",&p.x,&p.y);
	points[1]=p;

	for(int i=2; i<=n; i++)
	{
		fscanf(fin,"%d%d/n",&p.x,&p.y);
		points[i]=p;

		if ((p.x<points[posxMin].x) || (p.x==points[posxMin].x && p.y<points[posxMin].y))
			posxMin=i;

		if ((p.x>points[posxMax].x) || (p.x==points[posxMax].x && p.y>points[posxMax].y))
			posxMax=i;

		if ((p.y<points[posyMin].y) || (p.y==points[posyMin].y && p.x<points[posyMin].x))
			posyMin=i;

		if ((p.y>points[posyMax].y) || (p.y==points[posyMax].y && p.x>points[posyMax].x))
			posyMax=i;
	}

	if (posxMin>4)
		swap(points[1],points[posxMin]);
	if (posxMax>4 && posxMax!=posxMin)
		swap(points[2],points[posxMax]);
	if (posyMin>4 && posyMin!=posxMin && posyMin!=posxMax)
		swap(points[3],points[posyMin]);
	if ((posyMax>4) && (posyMax!=posyMin) && (posyMax!=posxMin) && (posyMax!=posxMax))
			swap(points[4],points[posyMax]);

}
//-------------------------------------------------------------------
//return the smallest enclosing circle containin all points
TCircle smallestCircle()
{
	TCircle c=getCircle(points[1],points[2]);
	int i;
	for (i=3; i<=n; i++)
		if (distance(points[i],c.center)> c.radius)
			c = smallestCircle(points[i],i-1);
	return c;
}
//-------------------------------------------------------------------
//return the smallest enclosing circle containin first k points
//and passing from the point p.
TCircle smallestCircle(TIntPoint p,int k)
{
//	fprintf(fout,"two points: %d\n",k);
	TCircle c=getCircle(points[1],p);
	int i;
	for(i=2; i<=k; i++)
		if (distance(points[i],c.center)>c.radius)
			c=smallestCircle(points[i],p,i-1);
	return c;
}
//-------------------------------------------------------------------
//return the smallest eclosing circle containin first k points
//and passing form the points p and q.
TCircle smallestCircle(TIntPoint p, TIntPoint q, int k)
{
	TCircle c=getCircle(p,q);
	int i;
//	fprintf(fout,"three points: %d\n",k);
	for(i=1; i<=k; i++)
		if (distance(points[i],c.center) > c.radius)
//			if(!collinear(p,q,points[i]))
				c = getCircle(p,q,points[i]);
	return c;
}
//-------------------------------------------------------------------
//return the smallest circle passing from the points p1 and p2.
TCircle getCircle(TIntPoint p1, TIntPoint p2)
{
	TCircle c;
	c.center.x = (float)(p1.x + p2.x)/2;
	c.center.y = (float)(p1.y + p2.y)/2;
	c.radius = distance(p1,p2)/2;
	return c;
}
//-------------------------------------------------------------------
//return the circle passing from the points pa, pb and pc.
TCircle getCircle(TIntPoint pa, TIntPoint pb, TIntPoint pc)
{
	TCircle c;
	TPoint p1,p2,p3;
	p1.x=pa.x; p1.y=pa.y; p2.x=pb.x; p2.y=pb.y; p3.x=pc.x; p3.y=pc.y;

	c.center.x = ((pow(p1.x,2)+pow(p1.y,2))*(p3.y-p2.y)+(pow(p2.x,2)+pow(p2.y,2))*(p1.y-p3.y)+
					 (pow(p3.x,2)+pow(p3.y,2))*(p2.y-p1.y))/
				 (2*(p1.x*(p3.y-p2.y)+p2.x*(p1.y-p3.y)+p3.x*(p2.y-p1.y)));

	c.center.y = ((pow(p1.x,2)+pow(p1.y,2))*(p3.x-p2.x)+(pow(p2.x,2)+pow(p2.y,2))*(p1.x-p3.x)+
					 (pow(p3.x,2)+pow(p3.y,2))*(p2.x-p1.x))/
				 (2*(p1.y*(p3.x-p2.x)+p2.y*(p1.x-p3.x)+p3.y*(p2.x-p1.x)));

	c.radius = distance(p1,c.center);
	return c;
}
//-------------------------------------------------------------------
//return true if the points p1, p2 and p3 are collinear.
bool collinear(TIntPoint p1, TIntPoint p2, TIntPoint p3)
{
return  (p1.x*p2.y + p2.x*p3.y + p3.x*p1.y ==
			p2.x*p1.y + p3.x*p2.y + p1.x*p3.y);
}
//-------------------------------------------------------------------
//swap p1 and p2
void swap(TIntPoint &p1, TIntPoint &p2)
{
	TIntPoint tempP = p1;
	p1=p2;
	p2=tempP;
}


